[BACK]Return to fw_install.sh CVS log [TXT][DIR] Up to [local] / openbsd / fw_update

Annotation of openbsd/fw_update/fw_install.sh, Revision 1.89

1.1       afresh1     1: #!/bin/ksh
1.36      afresh1     2: #      $OpenBSD$
1.50      afresh1     3: #
1.38      afresh1     4: # Copyright (c) 2021 Andrew Hewus Fresh <afresh1@openbsd.org>
                      5: #
                      6: # Permission to use, copy, modify, and distribute this software for any
                      7: # purpose with or without fee is hereby granted, provided that the above
                      8: # copyright notice and this permission notice appear in all copies.
                      9: #
                     10: # THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
                     11: # WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
                     12: # MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
                     13: # ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
                     14: # WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
                     15: # ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
                     16: # OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
                     17:
1.50      afresh1    18: set -o errexit -o pipefail -o nounset
1.85      afresh1    19: set +o monitor
1.77      afresh1    20: export PATH=/usr/bin:/bin:/usr/sbin:/sbin
1.50      afresh1    21:
                     22: CFILE=SHA256.sig
                     23: DESTDIR=${DESTDIR:-}
                     24: FWPATTERNS="${DESTDIR}/usr/share/misc/firmware_patterns"
                     25:
                     26: VNAME=${VNAME:-$(sysctl -n kern.osrelease)}
                     27: VERSION=${VERSION:-"${VNAME%.*}${VNAME#*.}"}
                     28:
                     29: HTTP_FWDIR="$VNAME"
1.52      afresh1    30: VTYPE=$( sed -n "/^OpenBSD $VNAME\([^ ]*\).*$/s//\1/p" \
                     31:     /var/run/dmesg.boot | sed '$!d' )
1.50      afresh1    32: [[ $VTYPE == -!(stable) ]] && HTTP_FWDIR=snapshots
1.22      afresh1    33:
1.50      afresh1    34: FWURL=http://firmware.openbsd.org/firmware/${HTTP_FWDIR}
                     35: FWPUB_KEY=${DESTDIR}/etc/signify/openbsd-${VERSION}-fw.pub
1.8       afresh1    36:
1.87      afresh1    37: DOWNLOAD=true
                     38: INSTALL=true
1.69      afresh1    39: LOCALSRC=
                     40:
1.8       afresh1    41: tmpdir() {
                     42:        local _i=1 _dir
                     43:
1.50      afresh1    44:        # If we're not in the installer,
1.79      afresh1    45:        # we have mktemp and a more hostile environment.
1.50      afresh1    46:        if [ -x /usr/bin/mktemp ]; then
                     47:                _dir=$( mktemp -d "${1}-XXXXXXXXX" )
1.44      afresh1    48:        else
1.50      afresh1    49:                until _dir="${1}.$_i.$RANDOM" && mkdir -- "$_dir" 2>/dev/null; do
1.44      afresh1    50:                    ((++_i < 10000)) || return 1
                     51:                done
                     52:        fi
1.50      afresh1    53:
1.8       afresh1    54:        echo "$_dir"
                     55: }
1.6       afresh1    56:
1.50      afresh1    57: fetch() {
1.85      afresh1    58:        local _src="${FWURL}/${1##*/}" _dst=$1 _user=_file _pid _exit
1.6       afresh1    59:
1.79      afresh1    60:        # If we're not in the installer,
                     61:        # we have su(1) and doas(1) is unlikely to be configured.
1.85      afresh1    62:        set -o monitor # make sure ftp gets its own process group
                     63:        (
1.53      afresh1    64:        if [ -x /usr/bin/su ]; then
1.85      afresh1    65:                exec /usr/bin/su -s /bin/ksh "$_user" -c \
1.69      afresh1    66:                    "/usr/bin/ftp -D 'Get/Verify' -Vm -o- '$_src'" > "$_dst"
1.42      afresh1    67:        else
1.85      afresh1    68:                exec /usr/bin/doas -u "$_user" \
1.69      afresh1    69:                    /usr/bin/ftp -D 'Get/Verify' -Vm -o- "$_src" > "$_dst"
1.42      afresh1    70:        fi
1.85      afresh1    71:        ) & _pid=$!
                     72:        set +o monitor
                     73:
                     74:        trap "kill -TERM '-$_pid'; exit 1" EXIT INT QUIT ABRT TERM
                     75:
                     76:        SECONDS=0
                     77:        _last=0
                     78:        while kill -0 -"$_pid" 2>/dev/null; do
                     79:                if [[ $SECONDS -gt 12 ]]; then
                     80:                        set -- $( ls -ln "$_dst" 2>/dev/null )
                     81:                        if [[ $_last -ne $5 ]]; then
                     82:                                _last=$5
                     83:                                SECONDS=0
                     84:                                sleep 1
                     85:                        else
                     86:                                kill -INT -"$_pid"
                     87:                                echo "fetch timed out" >&2
                     88:                        fi
                     89:                else
                     90:                        sleep 1
                     91:                fi
                     92:        done
                     93:
                     94:        set +o errexit
                     95:        wait "$_pid"
                     96:        _exit=$?
                     97:        set -o errexit
                     98:
                     99:        trap "" EXIT INT QUIT ABRT TERM
1.6       afresh1   100:
1.50      afresh1   101:        if [ "$_exit" -ne 0 ]; then
1.69      afresh1   102:                rm -f "$_dst"
                    103:                echo "Cannot fetch $_src" >&2
1.50      afresh1   104:                return 1
                    105:        fi
1.6       afresh1   106: }
                    107:
1.50      afresh1   108: verify() {
                    109:        # On the installer we don't get sha256 -C, so fake it.
1.69      afresh1   110:        if ! fgrep -qx "SHA256 (${1##*/}) = $( /bin/sha256 -qb "$1" )" "$CFILE"; then
                    111:                echo "Checksum test for ${1##*/} failed." >&2
1.50      afresh1   112:                return 1
                    113:        fi
1.6       afresh1   114: }
                    115:
1.50      afresh1   116: devices_needing_firmware() {
1.83      afresh1   117:        local _d _m _line _dmesgtail _last=''
1.1       afresh1   118:
1.50      afresh1   119:        # When we're not in the installer, the dmesg.boot can
                    120:        # contain multiple boots, so only look in the last one
1.89    ! afresh1   121:        _dmesgtail="$( echo ; sed -n 'H;/^OpenBSD/h;${g;p;}' /var/run/dmesg.boot |
        !           122:            grep -e "^[a-z][a-z]*[0-9]" -e " not configured " )"
1.50      afresh1   123:
1.89    ! afresh1   124:        grep -v '^[[:space:]]*#' "$FWPATTERNS" |
        !           125:            while read -r _d _m; do
        !           126:                [ "$_d" = "$_last" ] && continue
        !           127:                [ "$_m" ] || _m="^${_d}[0-9] at "
1.50      afresh1   128:
1.89    ! afresh1   129:                if [ "$_m" != "${_m#^}" ]; then
        !           130:                        _m="$( echo -n "\n${_m#^}" )"
        !           131:                fi
1.83      afresh1   132:
1.89    ! afresh1   133:                if [[ $_dmesgtail = *$_m* ]]; then
        !           134:                        echo "$_d"
        !           135:                        _last="$_d"
        !           136:                fi
        !           137:            done
1.50      afresh1   138: }
1.14      afresh1   139:
1.50      afresh1   140: firmware_filename() {
1.56      afresh1   141:        local _f
                    142:        _f="$( sed -n "s/.*(\($1-firmware-.*\.tgz\)).*/\1/p" "$CFILE" | sed '$!d' )"
                    143:        ! [ "$_f" ] && echo "Unable to find firmware for $1" >&2 && return 1
                    144:        echo "$_f"
1.50      afresh1   145: }
1.7       afresh1   146:
1.57      afresh1   147: firmware_devicename() {
                    148:        local _d="${1##*/}"
                    149:        _d="${_d%-firmware-*}"
                    150:        echo "$_d"
                    151: }
                    152:
1.50      afresh1   153: installed_firmware() {
                    154:        for fw in "${DESTDIR}/var/db/pkg/$1-firmware"*; do
                    155:                [ -e "$fw" ] || continue
                    156:                echo "${fw##*/}"
                    157:        done
                    158: }
1.1       afresh1   159:
1.50      afresh1   160: add_firmware () {
1.74      afresh1   161:        local _f="${1##*/}"
                    162:        local _pkgdir="${DESTDIR}/var/db/pkg/${_f%.tgz}"
1.50      afresh1   163:        ftp -D "Install" -Vmo- "file:${1}" |
1.73      afresh1   164:                tar -s ",^\+,${_pkgdir}/+," \
1.69      afresh1   165:                    -s ",^firmware,${DESTDIR}/etc/firmware," \
                    166:                    -C / -zxphf - "+*" "firmware/*"
1.1       afresh1   167:
1.50      afresh1   168:        # TODO: Should we mark these so real fw_update can -Drepair?
1.73      afresh1   169:        ed -s "${_pkgdir}/+CONTENTS" <<EOL
1.50      afresh1   170: /^@comment pkgpath/ -1a
                    171: @option manual-installation
                    172: @option firmware
                    173: @comment install-script
                    174: .
                    175: w
                    176: EOL
                    177: }
1.22      afresh1   178:
1.50      afresh1   179: delete_firmware() {
1.51      afresh1   180:        local _cwd _pkg="$1" _pkgdir="${DESTDIR}/var/db/pkg"
1.22      afresh1   181:
1.50      afresh1   182:        # TODO: Check hash for files before deleting
                    183:        echo "Uninstalling $_pkg"
1.51      afresh1   184:        _cwd="${_pkgdir}/$_pkg"
1.50      afresh1   185:
1.51      afresh1   186:        set -A _remove -- "${_cwd}/+CONTENTS" "${_cwd}"
1.50      afresh1   187:
                    188:        while read -r c g; do
                    189:                case $c in
1.51      afresh1   190:                @cwd) _cwd="${DESTDIR}$g"
1.50      afresh1   191:                  ;;
                    192:                @*) continue
                    193:                  ;;
1.52      afresh1   194:                *) set -A _remove -- "$_cwd/$c" "${_remove[@]}"
1.50      afresh1   195:                  ;;
                    196:                esac
                    197:        done < "${_pkgdir}/${_pkg}/+CONTENTS"
                    198:
                    199:        # We specifically rm -f here because not removing files/dirs
                    200:        # is probably not worth failing over.
                    201:        for _r in "${_remove[@]}" ; do
                    202:                if [ -d "$_r" ]; then
                    203:                        # Try hard not to actually remove recursively
                    204:                        # without rmdir on the install media.
                    205:                        [ "$_r/*" = "$( echo "$_r"/* )" ] && rm -rf "$_r"
                    206:                else
                    207:                        rm -f "$_r"
1.22      afresh1   208:                fi
                    209:        done
1.50      afresh1   210: }
1.1       afresh1   211:
1.59      afresh1   212: usage() {
1.88      afresh1   213:        echo "usage: fw_install [-D | -L] [driver | file ...]"
1.59      afresh1   214:        exit 2
                    215: }
                    216:
1.87      afresh1   217: OPT_D=
                    218: OPT_L=
1.82      afresh1   219: while getopts DL name
1.59      afresh1   220: do
                    221:        case "$name" in
1.87      afresh1   222:        D) OPT_D=true ;;
                    223:        L) OPT_L=true ;;
1.59      afresh1   224:        ?) usage 2 ;;
                    225:        esac
                    226: done
                    227: shift $((OPTIND - 1))
                    228:
1.87      afresh1   229: [ "$OPT_D" ] && [ "$OPT_L" ] && usage 1
                    230:
                    231: if [ "$OPT_D" ]; then
                    232:        # "Download only" means local dir and don't install
                    233:        INSTALL=false
                    234:        LOCALSRC=.
                    235: elif [ "$OPT_L" ]; then
                    236:        # "Local" means don't download, install from local dir
                    237:        DOWNLOAD=false
                    238:        LOCALSRC=.
                    239: else
                    240:        LOCALSRC="$( tmpdir "${DESTDIR}/tmp/fw_install" )"
                    241: fi
1.64      afresh1   242:
1.78      afresh1   243: CFILE="$LOCALSRC/$CFILE"
                    244:
1.58      afresh1   245: set -A devices -- "$@"
                    246:
                    247: [ "${devices[*]:-}" ] ||
                    248:     set -A devices -- $( devices_needing_firmware )
1.1       afresh1   249:
1.65      afresh1   250: if [ ! "${devices[*]:-}" ]; then
1.50      afresh1   251:        echo "No devices found which need firmware files to be downloaded."
                    252:        exit
                    253: fi
                    254:
1.71      afresh1   255: if "$DOWNLOAD"; then
1.64      afresh1   256:        fetch "$CFILE"
                    257:        ! signify -qVep "$FWPUB_KEY" -x "$CFILE" -m "$CFILE" &&
                    258:            echo "Signature check of SHA256.sig failed" >&2 && exit 1
                    259: fi
1.50      afresh1   260:
1.70      afresh1   261: for f in "${devices[@]}"; do
                    262:        d="$( firmware_devicename "$f" )"
                    263:
1.58      afresh1   264:        if [ "$f" = "$d" ]; then
                    265:                f=$( firmware_filename "$d" || true )
                    266:                [ "$f" ] || continue
1.69      afresh1   267:                f="$LOCALSRC/$f"
1.76      afresh1   268:        elif ! "$INSTALL" && ! grep -Fq "($f)" "$CFILE" ; then
1.70      afresh1   269:                echo "Cannot download local file $f" >&2
                    270:                exit 2
1.58      afresh1   271:        fi
                    272:
1.50      afresh1   273:        set -A installed -- $( installed_firmware "$d" )
                    274:
1.68      afresh1   275:        if "$INSTALL" && [ "${installed[*]:-}" ]; then
1.65      afresh1   276:                for i in "${installed[@]}"; do
1.58      afresh1   277:                        if [ "${f##*/}" = "$i.tgz" ]; then
1.50      afresh1   278:                                echo "$i already installed"
1.11      afresh1   279:                                continue 2
1.1       afresh1   280:                        fi
                    281:                done
1.50      afresh1   282:        fi
1.1       afresh1   283:
1.72      afresh1   284:        if [ -e "$f" ]; then
                    285:                if "$DOWNLOAD"; then
                    286:                        echo "Verify existing ${f##*/}"
                    287:                        verify "$f" || continue
                    288:                # else assume it was verified when downloaded
                    289:                fi
1.75      afresh1   290:        elif "$DOWNLOAD"; then
                    291:                fetch  "$f" || continue
                    292:                verify "$f" || continue
                    293:        elif "$INSTALL"; then
1.72      afresh1   294:                echo "Cannot install ${f##*/}, not found" >&2
                    295:                continue
1.58      afresh1   296:        fi
1.60      afresh1   297:
1.68      afresh1   298:        "$INSTALL" || continue
1.11      afresh1   299:
1.65      afresh1   300:        if [ "${installed[*]:-}" ]; then
1.50      afresh1   301:                for i in "${installed[@]}"; do
                    302:                        delete_firmware "$i"
                    303:                done
                    304:        fi
1.11      afresh1   305:
1.50      afresh1   306:        add_firmware "$f"
                    307: done
1.1       afresh1   308:

FreeBSD-CVSweb <freebsd-cvsweb@FreeBSD.org>